pro bpd_data,data_x,data_y
;
;+
; NAME: BPD_DATA
; PURPOSE:
;   entry of a line of data from the bitpad
; CATEGORY:
;   Bitpad, data entry
; CALLING SEQUENCE:
;   BPD_DATA,DATA_X,DATA_Y
; INPUTS:
;   none
; OPTIONAL INPUT PARAMETERS:
;   none
; KEYWORD PARAMETERS:
;   none
; OUTPUTS:
;   DATA_X - X coordinates of data entered
;   DATA_Y - Y coordinates of data entered
; OPTIONAL OUTPUT PARAMETERS:
;   none
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; MODIFICATION HISTORY:
;    Created by J.D. Trickey 15-DEC-1992
;-
;
common BPD_common,xtype,xmax,xmin,xscale,bp_x_offset,$
                  ytype,ymax,ymin,yscale,bp_y_offset,rot_angle 
;
fill=99999.9
;
print,'Begin entering data points on Bitpad; Use "End Entry" Command to end'
count=1l
command=0
while (command eq 0) do begin
   err=1
   while (err eq 1) do begin
      bitpad_read,bp_x,bp_y,i3,err
   endwhile
   bpd_control,bp_x,bp_y,command
   if command eq 0 then begin
      if (xtype eq 0) then begin
         point_x=float((bp_x-bp_x_offset)*cos(rot_angle)+$
                    (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin
      endif else begin
         point_x=10^(float((bp_x-bp_x_offset)*cos(rot_angle)+$
                    (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin)
      endelse
      if (ytype eq 0) then begin
         point_y=float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                       (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin
      endif else begin
         point_y=10^(float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                       (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin)
      endelse       
      if count eq 1 then begin
         data_x=[point_x]
         data_y=[point_y]
         oplot,[data_x],[data_y],psym=3,max_value=fill-1.
         empty
      endif else begin
         data_x=[temporary(data_x),point_x]
         data_y=[temporary(data_y),point_y]
         oplot,[data_x(count-2),data_x(count-1)],$
               [data_y(count-2),data_y(count-1)],psym=-3,max_value=fill-1.
         empty
      endelse
      count=count+1
   endif else begin
      case command of
         1: command=1
         2: begin
              n=n_elements(data_x)
              data_x=data_x(0:n-2)
              data_y=data_y(0:n-2)
              plot,data_x,data_y,xtype=xtype,ytype=ytype,psym=-3,max_value=fill-1.
              print,'Continue'
              count=count-1
              command=0
            end
        10: begin
              if count eq 1 then begin
                 data_x=[fill]
                 data_y=[fill]
              endif else begin
                 data_x=[temporary(data_x),fill]
                 data_y=[temporary(data_y),fill]
              endelse
              count=count+1              
              command=0
            end
       else: begin
              print,'*** Command Not Available ***'
              command=0
             end
       endcase
   endelse
endwhile
;
;
return
end
