pro type_convert,type,xtype,xstyle,ytype,ystyle,pticklen
;
;+
; NAME: Type_convert
; PURPOSE: Convert IDL 1 !type values to IDL 2
; CATEGORY: IDL 2 upgrade
; CALLING SEQUENCE:
;   type_convert,type,xtype,xstyle,ytype,ystyle,pticklen 
; INPUTS:
;     type = value set to IDL 1 !type
; OPTIONAL INPUT PARAMETERS: None
; KEYWORD PARAMETERS: None
; OUTPUTS:
;     xtype    - to be used to set !X.type
;     xstyle   - "  "    "      "  !X.style
;     ytype    - "  "    "      "  !Y.type
;     ystyle   - "  "    "      "  !Y.style
;     pticklen - "  "    "      "  !P.ticklen
; OPTIONAL OUTPUT PARAMETERS: None
; COMMON BLOCKS: None
; SIDE EFFECTS: None
; RESTRICTIONS: This procedure should only be used to simplify conversion
;    from IDL 1 to IDL 2. All new IDL 2 procedures should not use !TYPE,
;    so should not need this.
; PROCEDURE:
;	Straightforward.
; MODIFICATION HISTORY:
;    Created by J. D. Trickey - Dec. 1990
;-
xtype=0
xstyle=0
ytype=0
ystyle=0
pticklen=0.02
if (type and 1) ne 0 then begin
     xtype=1
endif
if (type and 2) ne 0 then begin
     ytype=1
endif
if (type and 4) ne 0 then begin
     xstyle=1
endif
if (type and 8) ne 0 then begin
     ystyle=1
endif
if (type and 16) eq 0 then begin
     xstyle=xstyle+8
     ystyle=ystyle+8
endif
if (type and 32) ne 0 then begin
     xstyle=xstyle+4
endif
if (type and 64) ne 0 then begin
     ystyle=ystyle+4
endif
if (type and 128) ne 0 then begin
     pticklen=-0.02
endif
;
return
end
