;+
; NAME:
;       CEWIDGETS
; PURPOSE:
;		A graphical widget interface to cadi idl plotting programs
;		The main program is CEWIDGETS and the widget callback event routines that do the plotting
;		are in procedure SIMPLE_EVENT
;		To run: compile and enter 'cewidgets' at the idl> command line
;		Thereafter just select menu items using the mouse
; MODIFICATION HISTORY:
;		JWM 4 April 2004
;-


pro simple_event, ev
on_error, 0
common widgetinfo, r1dlw1, r1dlw2, r1dlw3, r1dlw4,r1dlw5, r2dlw1, r2dlw2,r2dlw3,$
        fileextension, fileextensionstr, dtarr, dir, enddir, fixedfrequency,rowthreef,$
        r3dlw1, ffrequency, r3tw1, minheight, r3tw2, maxheight, r3dlw2, pltpanels,$
        r1tw1, r2bw1, r2dlw4, r2dlw5, noofrows, noofcolumns, r2dlw6, pincrement,$
        rowthreei, r3idlw1, iplttype, r3itw1, r3itw2, rowthreeii, r3iidlw1, nipanels,$
        r3iidlw2, noofcolumnsi, r3iidlw3, noofrowsi, rowthreetf, r3tftw1, r3tftw2,$
        r3bw, widgetds, datasave, r2vbw1, r2vdlw1, r2vdlw2, hvelsel, vvelsel,$
        r3ibw3, r3idlw2,  imapchoice, r3idlw3, imapdist, r3idlw4, imapcolor, r1baseh,$
        r1based, r1ddlw1, r1ddlw2, r1ddlw3,r1ddlw4,horzscalesel,r1ddlw5, vertscalesel,$
        r1ddbase2, r2stn2bw1, r2stn2bw2, r2stn2dlw1, dir2, enddir2, secondstation
stnid = ['eu','rb','cb','ra','de','fo','cx','pr', 'pk','rl','sl', 'lo', 'al', 'na','sj','al']
drive = ['C','D','E','F','G','A']
plotpanels = ['f','fAH','fXY','fAHV','fXYV','fAHVN','fXYVN','fAHVNahv','fXYVNahv',$
                  'ht4panelday','skymap','phase_cal','xydistance400', 'xydistance200',$
                  'xydistance100', 'xydistance50','summallhtv-ps', 'summallhtv-pcl','plot all fixedFreq']
hvelrange = [2000, 1000, 500, 200, 100, 50]
vvelrange = [400, 200, 150, 100, 50, 20]
;print,'iplttype =', iplttype
type = tag_names(ev, /structure_name)
;plot, [0.5,1.5],[0.5,1.5], color = 180
;print, 'type = ',type
if (type eq 'WIDGET_DROPLIST')then begin
;print, 'w-dl'
  t = ev.id
 ; print, 'r3idlw2 = ', r3idlw2
  ;print,'t = ',t
  i = ev.index
  if (t eq r1dlw1) then begin 		;year widget
        dtarr(0) = i             	;change year index in datetime array
        yrs = strtrim(1993+i,2)		;change year in directory string
        yr = strmid(yrs,2,2)
        strput,dir,yr,3
        ;dtarr(0) = i             	;change year index in datetime array
        ;yrs = strtrim(1993+i,2)		;change year in directory string
        ;yr = strmid(yrs,2,2)
        strput,dir2,yr,3
   endif
  if (t eq r1dlw2) then begin		;month widget
        dtarr(1) = i				;change month index in datetime array
        months = strtrim(1+i,2) 	;change month in directory string
        if (i lt 9) then begin
           strput,dir,'0',5
           strput,dir2,'0',5
           strput,dir,months,6
           strput,dir2,months,6
        endif else begin
           strput,dir,months,5
           strput,dir2,months,5
        endelse
    endif
  if (t eq r1dlw3) then begin		;day widget
        dtarr(2) = i				;change day index in datetime array
        days = strtrim(1+i,2) 	;change day in directory string
        if (i lt 9) then begin
           strput,dir,'0',7
           strput,dir2,'0',7
           strput,dir,days,8
           strput,dir2,days,8
        endif else begin
           strput,dir,days,7
           strput,dir2,days,7
        endelse
    endif
 ;repeat above if endday
 if (t eq r1ddlw1) then begin 		;year widget
        dtarr(0) = i             	;change year index in datetime array
        yrs = strtrim(1993+i,2)		;change year in directory string
        yr = strmid(yrs,2,2)
        strput,enddir,yr,3
        strput,enddir2,yr,3
    endif
  if (t eq r1ddlw2) then begin		;month widget
        dtarr(1) = i				;change month index in datetime array
        months = strtrim(1+i,2) 	;change month in directory string
        if (i lt 9) then begin
           strput,enddir,'0',5
           strput,enddir2,'0',5
           strput,enddir,months,6
           strput,enddir2,months,6
        endif else begin
           strput,enddir,months,5
           strput,enddir2,months,5
        endelse
    endif
  if (t eq r1ddlw3) then begin		;day widget
        dtarr(2) = i				;change day index in datetime array
        days = strtrim(1+i,2) 	;change day in directory string
        if (i lt 9) then begin
           strput,enddir,'0',7
           strput,enddir2,'0',7
           strput,enddir,days,8
           strput,enddir2,days,8
        endif else begin
           strput,enddir,days,7
           strput,enddir2,days,7
        endelse
    endif
  if (t eq r1dlw4) then dtarr(3) = i	;hour widget
  if (t eq r1dlw5) then dtarr(5) = i	;number of hours to plot widget
  if (t eq r2dlw1) then begin			;station id widget
         strput,dir,stnid(i),9
         strput,enddir,stnid(i),9
         ;stationindex = i
    endif
  if (t eq r2stn2dlw1) then begin		;2nd station widget
        if i gt 0 then begin
        ;print, '2nd station'
        secondstation = !true
        strput,dir2,stnid(i-1),9
        strput,enddir2,stnid(i-1),9
        ;stationindex2 = i-1
        endif else secondstation = !false
  endif

  if (t eq r2dlw2) then begin  		;file extension widget
         fileextension = fileextensionstr(i)	;get fileextension from array
       if ((fileextension eq 'md1') OR (fileextension eq 'md3')) then begin
         if fileextension eq 'md3' then maxheight = 1020 else maxheight = 510
           fixedfrequency = !true
            widget_control,rowthreef, map = 1	;show widgets for fixed frequency plotting
            widget_control, rowthreei, map = 0	;turn off ionogram
            if maxheight eq 1020 then widget_control, r3tw2, set_value = '1020' else widget_control, r3tw2, set_value = '510'
          if plotpanels(pltpanels) eq 'summallhtv-ps' or plotpanels(pltpanels) eq 'summallhtv-pcl' then begin
                    widget_control, r1based, map = 1 				;turn on end day select
                    widget_control, r1ddbase2, map = 1				;turn on vel scale sel
                    widget_control, r1baseh, map = 0				;turn off hour select
            endif else begin  ;not summall
                    widget_control, r1baseh, map = 1				;turn on hour select
                    widget_control, r1ddbase2, map = 0				;turn off vel scale sel
                    widget_control, r1based, map = 0				;turn off day select
            endelse
        endif else begin			;fileextension = md2 or md4
           if fileextension eq 'md4' then maxheight = 1020 else maxheight = 510
           fixedfrequency = !false
           widget_control, rowthreef, map = 0  	;turn off widgets for fixed frequency plotting
           widget_control, rowthreei, map = 1	;turn on ionogram
           if maxheight eq 1020 then widget_control, r3itw2, set_value = '1020' else widget_control, r3itw2, set_value = '510'
           if iplttype eq 0 then widget_control, rowthreeii, map = 1  ;turn on display ionogram info
           widget_control, r2bw1, map = 0		;turn off widget for skymaps
           widget_control, r2vbw1, map = 0		;turn off velocity range select
           widget_control, r1based, map = 0		;turn off end day select
           widget_control, r1ddbase2, map = 0	;turn off vel scale sel
           widget_control, r1baseh, map = 1		;turn on hour select
        endelse
    endif
  if (t eq r2dlw3) then begin
      strput,dir,drive(i),0	;get drive letter and put in directory name
      strput,enddir,drive(i),0
      ;if secondstation eq !true then begin
        strput,dir2,drive(i),0	;get drive letter and put in directory name
        strput,enddir2,drive(i),0
      ;endif
  endif
  ;print, dir
  if (t eq r3dlw1) then ffrequency = i			;get fixed frequency number
  if (t eq r3dlw2) then begin					;get which fixed freq to run
    pltpanels = i
    print, 'pltpanels = ',pltpanels								;select panels to plot
   if (plotpanels(pltpanels) eq 'skymap') then widget_control,r2bw1, map = 1 $
    else widget_control,r2bw1, map = 0
   ;if (plotpanels(pltpanels) eq '2 station timeshift ') then begin	;timeshift turn on 2nd station select
;print, 'timeshift'
    ;  widget_control, r2stn2bw1, map = 1
    ; endif else widget_control, r2stn2bw1, map = 0
    if (i gt 0 and i lt 9) then widget_control, r2vbw1, map = 1 else $			;turn on/off velocity range select
      widget_control, r2vbw1, map = 0
    if (plotpanels(pltpanels) eq 'summallhtv-ps' or plotpanels(pltpanels) eq 'summallhtv-pcl') then begin
       widget_control, r1baseh, map = 0 	;turn off hour select
       widget_control, r1based, map = 1 	;turn on end day select
       widget_control, r1ddbase2, map = 1	;turn on vel scale sel
    endif else begin
       widget_control, r1baseh, map = 1		;turn on hour select
       widget_control, r1based, map = 0  	;turn off end day select
       widget_control, r1ddbase2, map = 0	;turn off vel scale sel
    endelse
  endif
  if (t eq r2vdlw1) then hvelsel = i		;get horizontal velocity index
  if (t eq r1ddlw4) then horzscalesel = i	;horz scale for summall
  if (t eq r2vdlw2) then vvelsel = i		;get vertical velocity index
  if (t eq r1ddlw5) then vertscalesel = i	;vert scale for summall
  if (t eq widgetds) then datasave = i		;toggle data save

  if (t eq r2dlw4) then noofcolumns = i+1		;for skymap get no of columns
  if (t eq r2dlw5) then noofrows = i+1			;for skymap get no of rows
  if (t eq r2dlw6) then pincrement = i+1		;for skymaps set time increment per plot
  if (t eq r3iidlw1) then nipanels = i+1		;for ionograms set no of panels
  if (t eq r3iidlw2) then noofcolumnsi = i+1	;for ionogram get no of columns
  if (t eq r3iidlw3) then  noofrowsi = i+1		;for ionograms get no of rows
  if (t eq r3idlw1) then begin					;for ionogram data select type of plot
    iplttype = i
    if (iplttype gt 0) then widget_control, rowthreeii, map = 0 else $	;control for igram select number of panels
                               widget_control, rowthreeii, map = 1      ;turn off if not ionograms
    if (iplttype eq 1) or (iplttype eq 2) or (iplttype eq 3) then widget_control, rowthreetf, map = 1 else $
         widget_control, rowthreetf, map = 0	                            ;turn on freqrange and heightrange select
    if (iplttype eq 5) then widget_control, r3ibw3, map = 1 else widget_control, r3ibw3, map = 0
    if (iplttype eq 6 or iplttype eq 7) then begin
       widget_control, r1baseh, map = 0 	;turn off hour select
       widget_control, r1based, map = 1 	;turn on end day select
    endif else begin
       widget_control, r1baseh, map = 1		;turn on hour select
       widget_control, r1based, map = 0  	;turn off end day select
    endelse
  endif
  if (t eq r3idlw2) then imapchoice = i			;for ionogram map select axis choice
  if (t eq r3idlw3) then imapdist = i			;for ionogram map select distance
  if (t eq r3idlw4) then imapcolor = i			;for ionogram map select color shows db or freq
endif else if (type eq 'WIDGET_BUTTON')then begin	;end widget_droplist, start widget_button
 widget_control,ev.id,get_value = value

;::::::::::::::::::run is start of the main cadi example program::::::::::::::::::::::::::::::::

 if ((value eq 'run')OR(value eq 'run + plotfile')) then begin
    widget_control,r1tw1, set_value = '  **** running ****'
    if (value eq 'run + plotfile') then begin
      loadct, 0
      pdir = 'c:\plotfiles(temp)' + strmid(dir,2,9)
      print, 'pdir = ',pdir
    endif else loadct, 39
    tr = cantime(1993+dtarr(0), dtarr(1)+1, dtarr(2)+1, dtarr(3)) + [0, 3600L*(dtarr(5)+1)]
    print,'cantime = ', tr
    if (fixedfrequency eq !true) then begin
       widget_control, r3tw1, get_value = minheight_s		;note: read from text widget returns a string array
       minheight = fix(minheight_s(0))
       if (minheight eq 0) then minheight = 1			;get height range: have problem if minheight eq 0
       widget_control, r3tw2, get_value = maxheight_s
       maxheight = fix(maxheight_s(0))
      if plotpanels(pltpanels) eq 'summallhtv-ps' or plotpanels(pltpanels) eq 'summallhtv-pcl' then begin
        if plotpanels(pltpanels) eq 'summallhtv-pcl' then begin
           spawnprocess = 1				;select pcl
           ps = 0						;not ps
        endif else begin
           spawnprocess = 0
           ps = 1
        endelse
        if strmid(dir,9,2) eq 'eu' or strmid(dir,9,2) eq 'rb' then ppanels = 'AH' else ppanels = 'XY'
        print, 'start summsite'
        summsite, ht_ext=0, ig_ext=0, hv_ext=fileextension, drive = strmid(dir,0,1), $
              site_code2=strmid(dir,9,2), ht_freqx=0, $
              hv_freqh=ffrequency, hv_freqv=ffrequency, $
              start_yymmdd=strmid(dir,3,6), end_yymmdd=strmid(enddir,3,6), $
              vertscale=vvelrange(vertscalesel), horzscale=hvelrange(horzscalesel), panels = ppanels, $
              data_subdir = '', ps = ps, jpeg = 0, spawnprocess = spawnprocess, $
              heightrange = [minheight,maxheight]

      endif else $
      if (plotpanels(pltpanels) ne 'ht4panelday') and (plotpanels(pltpanels) ne 'plot all fixedFreq') then begin		;did not select ht 4 panel day
      ;print
      ;print, 'here'
      ;print
        ;have cantime so read files
         gil_ht   = cadi_read_dir(dir=dir, ext=fileextension, timerange=tr, tfh=0, /inf,$
                                                htlimitmin = minheight, htlimitmax = maxheight)  ; Read all freqs
        if (gil_ht.header_exists eq 0) then print, 'error in reading file header' else print, 'first read done'
        ;stop
        if (secondstation eq !true) then begin
          gil_ht2  = cadi_read_dir(dir=dir2, ext=fileextension, timerange=tr, tfh=0, /inf,$
                                               htlimitmin = minheight, htlimitmax = maxheight)  ; Read all freqs
          if (gil_ht2.header_exists eq 0) then print, 'error in reading 2nd file header' else print, 'first read stn #2 done'
        endif

       gil_4mhz = cadi_read_dir(dir=dir, ext=fileextension, timerange=tr, fr=[ffrequency,ffrequency],$
            /inf ,htlimitmin = minheight, htlimitmax = maxheight)
        print, 'second read done
       if (secondstation eq !true) then begin
         gil_4mhz2 = cadi_read_dir(dir=dir2, ext=fileextension, timerange=tr, fr=[ffrequency,ffrequency],$
            /inf ,htlimitmin = minheight, htlimitmax = maxheight)
         print, 'second read of stn #2 done'
       endif
  ;skymap procedure
        if ((plotpanels(pltpanels) eq 'skymap') or (plotpanels(pltpanels) eq 'xydistance400') or $
          (plotpanels(pltpanels) eq 'xydistance200') or (plotpanels(pltpanels) eq 'xydistance100') or $
            (plotpanels(pltpanels) eq 'xydistance50')) then begin
          gil_4mhz_kvec = cadi_xap2kvec( cadi_iq2xap( gil_4mhz )) ; Convert 4 MHz IQ data to k-vectors
          dummy = cadi_tblocks(gil_4mhz_kvec.data, ntimes=tcount)                         ; How many times have data for a skymap?
          ;!p.background = 255
          ;!p.color = 0
          ;erase
          if (plotpanels(pltpanels) eq 'skymap') then begin		;do skymap
            if (value eq 'run + plotfile') then cc = 1 else cc = 0
            cadi_skymaps, gil_4mhz_kvec, /overplot, fstep=2, ncols=noofcolumns,nrows=noofrows,$
              timex = pincrement*indgen(noofrows*noofcolumns), $    ; Plot 12 skymaps in a 3*4 grid
               nocolor=cc, axismax = 1.0, pos_regions = [0.03, -1.0, 0.85, 0.95], /publication
            if (value eq 'run + plotfile') then begin
              prohardcopy, /ps, file= pdir + '.pss'
              cadi_skymaps, gil_4mhz_kvec, /overplot, fstep=2, ncols=noofcolumns,nrows=noofrows,$
                timex=pincrement*lindgen(noofrows*noofcolumns), $    ; Plot 12 skymaps in a 3*4 grid
               /nocolor, axismax = 1.0, pos_regions = [0.03,-1,0.85,0.95], /publication
            endif
          endif else begin  									;do xydistance
            if (plotpanels(pltpanels) eq 'xydistance400') then distance = 400
            if (plotpanels(pltpanels) eq 'xydistance200') then distance = 200
            if (plotpanels(pltpanels) eq 'xydistance100') then distance = 100
            if (plotpanels(pltpanels) eq 'xydistance50') then distance = 50
            cadi_xydistance, gil_4mhz_kvec, timerange = tr, /colour, distance = distance
            if (value eq 'run + plotfile') then begin
              prohardcopy, /ps, file = pdir + '.psx'
              cadi_xydistance, gil_4mhz_kvec, timerange = tr, /colour, distance = distance
            endif
        endelse
;phase calibration
        endif else begin							 ;phase calibrate or just 'ordinary' htv plots
          if(plotpanels(pltpanels) eq 'phase_cal') then begin	;do phasecalibration
            print, 'phase calibration plots'
            cadi_phase_cal, gil_4mhz, /colour
            if (value eq 'run + plotfile') then begin
              prohardcopy, /ps, file = pdir + '.psp'
              cadi_phase_cal, gil_4mhz, /colour
        endif
;htvplots
          endif else begin
          ;print, 'hereA'										;do htv plots
            if datasave eq 1 then begin							;first see if datasave is asked for
              if plotpanels(pltpanels) eq 'f' then dumph = 1 else dumph = 0	;save only t-h data
              if pltpanels gt 0 and pltpanels lt 9 then dumpv = 1 else dumpv = 0 ;save thv
            endif else begin		;datasave eq 0 so dont save anything
              dumph = 0
              dumpv = 0
            endelse
            vel = cadi_iq2vel( gil_4mhz )                                                   ; Convert 4 MHz IQ data to velocities
            vel_edit = cadi_vel_edit(vel, nsource=5, azi=10000, hor=400, ver=100, /drop)  ; Flag poor quality velocities as missing
            if (secondstation eq !true) then begin
             vel2 = cadi_iq2vel( gil_4mhz2 )                                                   ; Convert 4 MHz IQ data to velocities
             vel_edit2 = cadi_vel_edit(vel2, nsource=5, azi=10000, hor=400, ver=100, /drop)  ; Flag poor quality velocities as missing
             cadi_htv2, gil_ht, gil_ht2, vel1=vel_edit, vel2=vel_edit2, timer=tr, panel= plotpanels(pltpanels), fr=[ffrequency],$
              hor = hvelrange(hvelsel),ver = vvelrange(vvelsel), /inf ,maxheight = maxheight, minheight = minheight, /colour, dumph = dumph, dumpv = dumpv
            endif else $
            cadi_htv, gil_ht, vel=vel_edit, timer=tr, panel= plotpanels(pltpanels), fr=[ffrequency],$
              hor = hvelrange(hvelsel),ver = vvelrange(vvelsel), /inf ,maxheight = maxheight, minheight = minheight, /colour, dumph = dumph, dumpv = dumpv
            if (value eq 'run + plotfile') then begin
              prohardcopy, /ps, file= pdir + '.psh'
             if (secondstation eq !true)  then cadi_htv2, gil_ht, gil_ht2, vel1=vel_edit, vel2=vel_edit2, timer=tr, panel= plotpanels(pltpanels), fr=[ffrequency],$
                 hor = hvelrange(hvelsel),ver = vvelrange(vvelsel), /inf ,maxheight = maxheight, minheight = minheight, /colour else $
              cadi_htv, gil_ht, vel=vel_edit, timer=tr, panel= plotpanels(pltpanels), fr=[ffrequency],$
                 hor = hvelrange(hvelsel),ver = vvelrange(vvelsel), /inf ,maxheight = maxheight, minheight = minheight, /colour    ; Plot 4 Mhz h't and velocity
              if (secondstation eq !true)  then cadi_htv2, gil_ht, gil_ht2, vel1=vel_edit, vel2=vel_edit2, timer=tr, panel= plotpanels(pltpanels), fr=[ffrequency],$
                 hor = hvelrange(hvelsel),ver = vvelrange(vvelsel), /inf ,maxheight = maxheight, minheight = minheight, /colour
          endif
          endelse ;end just htvplots
        endelse ;end phase cal or htv plots
      endif else begin
 ;do 4 panel ht day, or plt all fixedFreq
        ;yymmddstr = '';strmid(dtarr(0)+1993,2,2)
        if (plotpanels(pltpanels) eq 'ht4panelday') then begin
          cadi_htsumm, dir=dir, ext=fileextension, freqx=ffrequency, /inform, heightrange = [minheight,maxheight]
          if (value eq 'run + plotfile') then begin
            prohardcopy, /ps, file = pdir + '.psd'
            cadi_htsumm, dir=dir, ext=fileextension, freqx=ffrequency, /inform, heightrange = [minheight,maxheight]
          endif
        endif else begin
          cadi_htsumm, dir=dir, ext=fileextension, freqx=ffrequency, /inform, /allfreq, $
              heightrange = [minheight,maxheight], timerange = tr
          if (value eq 'run + plotfile') then begin
            prohardcopy, /ps, file = pdir + '.psd'
            cadi_htsumm, dir=dir, ext=fileextension, freqx=ffrequency, /inform, /allfreq, $
              heightrange = [minheight,maxheight], timerange = tr
          endif
        endelse
      endelse
    endif else begin;******* end fixed frequency start ionogram **************************************
      ;if (value eq 'run + plotfile') then loadct, 0  else loadct, 39
      widget_control, r3tftw1, get_value = freqstr
      minfreq = float(freqstr)*1.0e6
      widget_control, r3tftw2, get_value = freqstr
      maxfreq = float(freqstr)*1.0e6
      widget_control, r3itw1, get_value = hgtstr
      minht = fix(hgtstr)
     widget_control, r3itw2, get_value = hgtstr
      maxht = fix(hgtstr)
       if (iplttype eq 0) then begin  							;do ionograms
 ;ionograms
         cadi_igwsumm, dir=dir, ext= fileextension, /inform, heightrange = [minht,maxht],$
          noofpanels = nipanels, noofcolumns = noofcolumnsi, noofrows = noofrowsi,$
           cantimein = tr, /colour
           ;, eldensityrange = eldensrange
        if (value eq 'run + plotfile') then begin
          print, 'doing ionograms -run and plotfile'
          prohardcopy, /ps, file = pdir + '.psi'
          cadi_igwsumm, dir=dir, ext= fileextension, /inform, heightrange = [minht,maxht],$
          noofpanels = nipanels, noofcolumns = noofcolumnsi,noofrows = noofrowsi,$
           cantimein = tr, /colour
        endif
      endif else if (iplttype eq 1) then begin   				;do plot t-hf
;t-h-f plots
        cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
          heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /colour
        if (value eq 'run + plotfile') then begin
          prohardcopy, /ps, file = pdir + '.pst'
          cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
           heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /colour
        endif
      endif else if (iplttype eq 2) then begin 					;do t-f plot
;t-f plots
;print, 'starting t-f'
         cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
          heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /tfplot, /colour;, /saveFT
        if (value eq 'run + plotfile') then begin
          prohardcopy, /ps, file = pdir + '.psf'
          cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
           heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /tfplot, /colour
        endif
      endif else if (iplttype eq 3) then begin 					;do t-f plot with scaling
;t-f plots /scale
;print, 'starting t-f'
         cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
          heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /tfplot, /colour,/scale;, /saveFT
        if (value eq 'run + plotfile') then begin
          prohardcopy, /ps, file = pdir + '.psf'
          cadi_htfsumm, dir=dir, timerange=tr, ext = fileextension, /inform, contour=0, $
           heightrange = [minht,maxht],freqrange = [minfreq,maxfreq], /tfplot, /colour,/scale
        endif
      endif else if (iplttype eq 4) then begin 											;do scale ionogram procedure
;scale ionograms
         cadi_igwscale, dir = dir, ext = fileextension, /inform, cantimein = tr, /colour, heightrange = [minht,maxht]
	  endif else if (iplttype eq 5) then begin
;map ionogram data
        if imapdist eq 0 then xrange = 400
        if imapdist eq 1 then xrange = 200
        if imapdist eq 2 then xrange = 100
            cadi_igwmap, dir = dir, ext = fileextension, cantimein = tr, /colour, heightrange = [minht,maxht],$
                 xrange = xrange, show = imapcolor, pchoice = imapchoice

      endif else if (iplttype eq 6 or iplttype eq 7) then begin
;summsite
       if iplttype eq 7 then begin
           spawnprocess = 1				;select pcl
           ps = 0						;not ps
        endif else begin
           spawnprocess = 0
           ps = 1
        endelse
        summsite, ht_ext=0, ig_ext=fileextension, hv_ext= 0, drive = strmid(dir,0,1), $
              site_code2=strmid(dir,9,2), ht_freqx=0, $
              hv_freqh=ffrequency, hv_freqv=ffrequency, $
              start_yymmdd=strmid(dir,3,6), end_yymmdd=strmid(enddir,3,6), $
              vertscale = 0, horzscale = 0, panels = ppanels, $
              data_subdir = '', ps = ps, jpeg = 0, spawnprocess = spawnprocess, $
              heightrange = [minheight,maxheight]

      endif  ;iplttype 6 or 7
;heightfrequencyscale
      if iplttype eq 8 then begin
       cadi_igwscale, dir = dir, ext = fileextension, /inform, cantimein = tr, /colour,$
            heightrange = [minht,maxht], /heightfrequencyscale
      endif ;iplttype eq 8
    endelse ;endionograms
   if (value eq 'run + plotfile') then prohardcopy

   widget_control,r1tw1,set_value = ' select new values '
 endif

 if (value eq 'done') then widget_control,ev.top, /destroy
 endif
; print, dtarr
end


;****************************************************************************************************************;
;*                                                                                                              *;
;*                                   main program                                                               *;
;*                                                                                                              *;
;****************************************************************************************************************;

pro cewidgets

on_error, 0
device, decomposed = 0
loadct, 39
common widgetinfo, r1dlw1, r1dlw2, r1dlw3, r1dlw4,r1dlw5, r2dlw1, r2dlw2, r2dlw3,$
           fileextension, fileextensionstr, dtarr, dir, enddir, fixedfrequency, rowthreef,$
           r3dlw1, ffrequency,r3tw1, minheight, r3tw2, maxheight,r3dlw2, plotpanels,$
           r1tw1, r2bw1,r2dlw4, r2dlw5, noofrows, noofcolumns, r2dlw6, pincrement,$
           rowthreei, r3idlw1, iplttype, r3itw1, r3itw2, rowthreeii, r3iidlw1, nipanels,$
           r3iidlw2, noofcolumnsi, r3iidlw3, noofrowsi, rowthreetf, r3tftw1, r3tftw2,$
           r3bw, widgetds, datasave , r2vbw1, r2vdlw1, r2vdlw2, hvelsel, vvelsel,$
           r3ibw3, r3idlw2, imapchoice, r3idlw3, imapdist, r3idlw4, imapcolor, r1baseh,$
           r1based, r1ddlw1, r1ddlw2, r1ddlw3,r1ddlw4,horzscalesel,r1ddlw5,vertscalesel,$
           r1ddbase2, r2stn2bw1, r2stn2bw2, r2stn2dlw1, dir2, enddir2, secondstation
           ;make these available to procedures
device, get_screen_size = screen     ;want to select appropriate widget sizes
pwidth = screen(0)-5
pheight = screen(1)*0.95
base = widget_base(frame = 3, xsize = pwidth,ysize = pheight)

;put on date selection widgets
dtarr = [0,0,0,0,0,0]
dir = 'c:\930101eu\'
dir2 = 'c:\930101eu\'
enddir2 = 'c\930101eu\'
enddir = 'c:\930101eu\'
fileextension = 'md1'
fixedfrequency = !true
ffrequency = 0
minheight = 90
maxheight = 510
plotpanels = 0
noofrows = 1
noofcolumns = 1
pincrement = 1
noofcolumnsi = 1
noofrowsi = 1
igramxaxis = 0
nipanels = 1
iplttype = 0
datasave = 0
vvelsel = 0
hvelsel = 0
imapchoice = 0
imapdist = 0
imapcolor = 0
horzscalesel = 0
vertscalesel = 0
secondstation = !false

rowonebase = widget_base(base,xoffset = 0, yoffset = 0)
rowone = widget_base(rowonebase,/row, xsize = 600)
;put on command widgets
commandbox = widget_base(rowone,/row,/frame)
r1bw1 = widget_button(commandbox, value = 'run')
r1bw2 = widget_button(commandbox, value = 'run + plotfile')
r1bw3 = widget_button(commandbox, value = 'done')
r1tw1 = widget_text(commandbox, /frame, value = '      select values ')
;date select widgets
r1wl= widget_label(rowone,value = '    date = ')
yearstr = string(indgen (20) + 1993)
r1dlw1 = widget_droplist(rowone, value = yearstr, uvalue = 0)	;year select widget
monthstr = [' january',' february',' march',' april',' may',' june',' july',' august',$
              ' september',' october',' november',' december']
r1dlw2 = widget_droplist(rowone,value = monthstr,uvalue=0)		;month select widget
day = indgen(31)+1
daystr = string(day)
r1dlw3 = widget_droplist(rowone, value = daystr,uvalue = 0)		;day select widget

;put on time select widgets
r1baseh = widget_base(rowonebase, map = 1,/row, xoffset = pwidth/2+20)
r1wl2 = widget_label(r1baseh,value = '  start time hours =')
r1dlw4 = widget_droplist(r1baseh,value = sindgen(24))			;hour select widget
r1wl3 = widget_label(r1baseh,value = '  do for hours =')
;nhrs = 1+indgen(24)
r1dlw5 = widget_droplist(r1baseh,value = string(1+indgen(24)))			;number of hours to plot widget

;end date select widgets
r1based = widget_base(rowonebase, map = 0,/row, xoffset = pwidth/2+20, xsize = 300)			;widgets to select end date for summall
r1dwl= widget_label(r1based,value = ' end date = ')
r1ddlw1 = widget_droplist(r1based, value = yearstr, uvalue = 0)	;year select widget
r1ddlw2 = widget_droplist(r1based,value = monthstr,uvalue=0)		;month select widget
r1ddlw3 = widget_droplist(r1based, value = daystr,uvalue = 0)		;day select widget

;as required for fixed frequency, scales widgets
r1ddbase2 = widget_base(rowonebase, map = 0,xoffset = 0.78*pwidth,/row)
r1dwl2 = widget_label(r1ddbase2, value = ' horzscale = ')
r1ddlw4 = widget_droplist(r1ddbase2, value = ['2000', '1000','500','200','100','50'])
r1dwl3 = widget_label(r1ddbase2, value = 'vertscale = ')
r1ddlw5 = widget_droplist(r1ddbase2, value = ['400', '200','150','100','50','20'])


;put on file and mode select widgets
rowtwo = widget_base(base,/row,yoffset = 30);, xsize = pwidth)
r2w1=widget_label(rowtwo, value = 'station =')
stationstr = ['Eureka','Resolute B', 'Cambridge B' ,'Rankin Inlet', 'Delaware', 'Fortaleza',$
       'Cachimbo', 'Parit Raja', 'Park Site', 'Rabbit L','SIL', 'London', 'Alert', 'Natal', 'Sao Jose', 'Aldibag?']
r2dlw1 = widget_droplist(rowtwo, value = stationstr)			;station select widget

;r2stn2bw1 = widget_base(rowtwo, /row, map = 1)
r2stn2lw1 = widget_label(rowtwo, value = '2nd station =')
;stationstr2 = ['Eureka   ','Resolute Bay  ', 'Cambridge Bay  ' ,'Rankin Inlet  ', 'Delaware   ', 'Fortaleza    ',$
;       'Cachimbo     ', 'Parit Raja    ', 'Park Site      ', 'Rabbit Lake     ','SIL      ', 'London   ']
r2stn2dlw1 = widget_droplist(rowtwo, value = ['NO',stationstr])			;station select widget


r2w2 = widget_label(rowtwo,value = 'file ext.=')
fileextensionstr = ['md1','md2','md3','md4']
r2dlw2 = widget_droplist(rowtwo, value = fileextensionstr)		;file extension select widget
r2w3 = widget_label(rowtwo, value = 'data drive = ')
drivestr = ['C','D', 'E', 'F', 'G','A']
r2dlw3 = widget_droplist(rowtwo, value = drivestr)				;drive letter select widget
;r2w4 = widget_label(rowtwo, value = 'subdir =')
;r2tw1 = widget_text(rowtwo, /editable, value = '')

;widgets for skymaps
r2bw1 = widget_base(rowtwo, /row, /frame, map = 0)
r2lw3 = widget_label(r2bw1, value = 'skymap: col')
r2dlw4 = widget_droplist(r2bw1,value = string(indgen(10)+1))		;widget to set no of columns in skymap
rdlw4 = widget_label(r2bw1, value = ' rows')
r2dlw5 = widget_droplist(r2bw1,value = string(indgen(8)+1))		;widget to set no ofrows in skymap
r2lw5 = widget_label(r2bw1, value = ' t inc/pnl = ')
r2dlw6 = widget_droplist(r2bw1, value = string(indgen(120)+1))	;widget to set t increment between skymap panels

;widgets for velocity scales
r2vbw1 = widget_base(rowtwo, map = 0, yoffset = 30, xoffset = 0.78*pwidth)
r2vbw2 = widget_base(r2vbw1, /row, /frame)
r2vlw1 = widget_label(r2vbw2, value = 'max vel:  hor =')
r2vdlw1 = widget_droplist(r2vbw2,value = ['2000','1000', '500', '200', '100', '50'])		;widget to set velocity range
r2vlw2 = widget_label(r2vbw2, value = '  vert = ')
r2vdlw2 = widget_droplist(r2vbw2,value = ['400','200', '150', '100','50','20'])		;widget to set vertical velocity range

;widgets for 2nd station timeshift
;r2stn2bw1 = widget_base(base, map = 0, yoffset = 30, xoffset = 0.5*pwidth)
;r2stn2bw2 = widget_base(r2stn2bw1, /row)
;r2stn2lw1 = widget_label(r2stn2bw2, value = '2nd station = ')
;stationstr2 = ['Eureka   ','Resolute Bay  ', 'Cambridge Bay  ' ,'Rankin Inlet  ', 'Delaware   ', 'Fortaleza    ',$
 ;     'Cachimbo     ', 'Parit Raja    ', 'Park Site      ', 'Rabbit Lake     ','SIL      ', 'London   ']
;r2stn2dlw1 = widget_droplist(r2stn2bw2, value = stationstr2)			;station select widget


;widgets for fixed frequency
rowthreebase = widget_base(base, yoffset = 60, xoffset = 0)
rowthreef = widget_base(rowthreebase,/row, yoffset = 0, xsize = pwidth)
r3w1 = widget_label(rowthreef, value = 'fixed frequency number = ')
r3dlw1 = widget_droplist(rowthreef, value = sindgen(7))			;select frequency widget
r3w2 = widget_label(rowthreef, value = 'minimum height = ')
r3tw1 = widget_text(rowthreef, /editable, value = '90')			;minimum height widget
r3w3 = widget_label(rowthreef, value = 'maximum height = ')
r3tw2 = widget_text(rowthreef, /editable, value = '510')		;maximum height widget
r3w4 = widget_label(rowthreef, value = 'select plot panels: ')
r3dlw2 = widget_droplist(rowthreef, value = ['height only','hght+vel.azi.+vel.mag.',$
     'hght+vel.ew+vel.ns ','hght+vel.az+mag+vel.vert','hght+vel.ew+ns+vel.vert',$
     'hght+vel.az+mag+vert+#sources ','hght+vel.ew+ns+vert+#sources ',$
     'hght+vel.az+mag+ver+#s+errors ','hght+vel.ew+ns+ver+#s+errors ',$
     'ht 4 panel whole day', 'SKYMAPS','phase calibration ',$
     'e-w, n-s distances (400km dist)',  'e-w, n-s distances (200km dist)',$
     'e-w, n-s distances (100km dist)','e-w, n-s distances (50km dist)','summallhtv-ps',$
     'summallhtv-pcl','plot all fixedFreq'])
widgetds = widget_droplist(rowthreef, value = ['no datasave', 'save htv data'])


;widgets for ionograms
rowthreei = widget_base(rowthreebase, map = 0 )
rowthreeib2 = widget_base(rowthreei,/row, map = 1, xsize = 450)
r3ilw1 = widget_label(rowthreeib2, value = ' type of plot = ')
r3idlw1 = widget_droplist(rowthreeib2, value = ['ionograms', 'time-height-freq plot', 'time-frequency plot',$
                             'time-freq plt & get fof2','scale ionograms', 'ionogram map','summallig-ps','summallig-pcl','scale h'', fo  '])
r3ilw2 = widget_label(rowthreeib2, value = '  height range (km): min = ')
r3itw1 = widget_text(rowthreeib2,/editable, value = '0', xsize = 5)		;height range min widget
r31lw3 = widget_label(rowthreeib2, value = ' max = ')
r3itw2 = widget_text(rowthreeib2, /editable, value = '510', xsize = 5)	;height range max widget
;ionogram panels selection
rowthreeii = widget_base(rowthreei, /row, xoffset = pwidth/2, map = 1)
r3ilw1 = widget_label(rowthreeii, value = 'ionogram: no of panels = ')
r3iidlw1 = widget_droplist(rowthreeii, value = [' 1 ', ' 2'])
r3ilw2 = widget_label(rowthreeii, value = ' no of columns = ')
r3iidlw2 = widget_droplist(rowthreeii, value = string(indgen(24) + 1))
r3ilw3 = widget_label(rowthreeii, value = ' no of rows per panel = ')
r3iidlw3 = widget_droplist(rowthreeii, value = string(indgen(12) + 1))
;widgets for ionogram thf and tf plots
rowthreetf = widget_base(rowthreei,/row, map = 0, yoffset = 0, xoffset = pwidth/2, ysize = 30)
r3tflw1 = widget_label(rowthreetf, value = 'frequency range (MHz): min = ')
r3tftw1 = widget_text(rowthreetf,/editable, value = '0', xsize = 5)		;frequency range min widget
r3tflw2 = widget_label(rowthreetf, value = ' max = ')
r3tftw2 = widget_text(rowthreetf, /editable, value = '20.0', xsize = 5)	;frequency range max widget
;ionogram mapping widgets
r3ibw3 = widget_base(rowthreei,/row, xoffset = pwidth/2, map = 0)
r3idlw2 = widget_droplist(r3ibw3, value = ['map east-west vs height','map north-south vs height',$
           'map east-west vs north-south'])
r3idlw3 = widget_droplist(r3ibw3, value = ['horiz dim 400km','hor dim 200km', 'hor dim 100km'])
r3idlw4 = widget_droplist(r3ibw3, value = ['color shows dB', 'color shows freq'])

;drawing widget
graphics = widget_draw(base, /frame, xsize = pwidth,ysize = pheight*0.85, yoffset = 90, $
      colors = 256)
widget_control, base,/realize
widget_control, get_value = window, graphics
wset,window														;setup to plot on drawing widget

xmanager,'simple', base
print,'done
end

