;+
; NAME:
;	CUMULATIVE_SUM
; PURPOSE:
;	Return cumulative sums of elements of a numeric vector.
; CALLING SEQUENCE:
;	Result = CUMULATIVE_SUM( X )
; INPUTS:
;	X: Numeric vector.
; OUTPUTS:
;	Result: Vector of same type and length as X.
;	   Result(i) = TOTAL( X(0:i) )
; PROCEDURE:
;	Repeat: Result(i) = Result(i-1) + X(i)
; MODIFICATION HISTORY:
;	Ian Grant, UWO, 12 May 1994: Written.
;-

function cumulative_sum, x

result = x
for i=1,n_elements(x)-1 do $
   result(i) = result(i-1) + x(i)

return, result
end
