;+
; NAME:
;	HOWMANY
; PURPOSE:
;	Returns number of non-zero elements.
;	Use like WHERE when you want only the number of elements WHERE would
;	return.
; CALLING SEQUENCE:
;	Result = HOWMANY(X)
; INPUTS:
;	X = Any variable.
; OUTPUTS:
;	Result = Scalar long integer. Number of non-zero elements in X.
; PROCEDURE:
;	Calls WHERE with count parameter.
; Example:
;	HOWMANY(X GT 100) returns the number of elements of X which exceed 100.
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, 16 Jul 1991, IDL2.
;	IFG, 23 Dec 1992: Added ON_ERROR.
;-

function howmany, x

; Returns number of non-zero elements in X.
;
; Ian Grant, NRC/HIA, 16 Jul 1991, IDL2.

on_error, 2
w = where(x, wcount)
return, wcount
end
