;+
; NAME:
;	POSMOD
; PURPOSE:
;	Modulus function returning non-negative result.
; CALLING SEQUENCE:
;	Result = POSMOD( NUMBER, MODULO )
; INPUTS:
;	NUMBER = Numeric scalar or vector.
;	MODULO = Numeric scalar.
; OUTPUTS:
;	Result = Numeric with dimensions of NUMBER. NUMBER modulo MODULO.
;	   Result is always in range 0.0 to MODULO, even if NUMBER is negative.
;	   NUMBER = n*MODULO + Result, n an integer.
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, 29 April 1991. No changes needed for IDL2.
;	IFG, 5 Jan 1993: Added ON_ERROR.
;-

function posmod, number,modulo

on_error, 2
return, ((number mod modulo) + modulo) mod modulo
end
