;+
; NAME:
;	PCHARSIZE
; PURPOSE:
;	Return character size implied by !P.CHARSIZE.
; CALLING SEQUENCE:
;	Result = PCHARSIZE()
; INPUTS:
;	None.
; OUTPUTS:
;	Result: If !P.CHARSIZE is zero then Result=1.0 else Result=!P.CHARSIZE.
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, 1991: Written in IDL2.
;	IFG, 21 Jan 1993: Added ON_ERROR.
;-

function pcharsize

   on_error, 2
   if !p.charsize gt 1e-6 then $
      charsize = !p.charsize $
   else $
      charsize = 1.0

return, charsize
end
