;+
; NAME:
;	RMS
; PURPOSE:
;	Returns root mean square of values in argument vector.
; CALLING SEQUENCE:
;	Result = RMS(X)
; INPUTS:
;	X = numeric array.
; OUTPUTS:
;	Result = Float scalar. Root mean square of the elements of X.
; RESTRICTIONS:
;	1-d for now.
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, 10 Oct 1990: Written in IDL1.
;	IFG  6 Feb 1991: No changes needed for IDL2.
;	IFG  5 Jan 1993: Added ON_ERROR.
;-

function rms, x

on_error, 2
return, sqrt(total(x*x)/n_elements(x))
end
