;+
; NAME:
;	VECT3_MAG
; PURPOSE:
;	Returns the magnitude of a 3-component vector.
; CALLING SEQUENCE:
;	Result = VECT3_MAG(V)
; INPUTS:
;	V = 3-element vector.
; OUTPUTS:
;	Result = floating scalar. The magnitude of V.
; RESTRICTIONS:
;	Vector must have 3 elements.
; PROCEDURE:
;	|v| = sqrt( a1*a1 + b1*b1 + c1*c1 )
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, Aug 1990: Written.
;	IFG, 6 May 1991: IDL1? Looks like this will run under IDL2.
;	GRANT, 16 Jun 1994: Fixed mistake in comments.
;-

function vect3_mag,v
	on_error,2                      ;Return to caller if an error occurs
	return, sqrt(total(v*v))
end
